<jnt-app-body>
    <jnt-container>
        <h1>Junte Encapsuler</h1>

        <h3>Version</h3>

        <jnt-link source="https://www.npmjs.com/package/junte-encapsuler">npm</jnt-link>
        v0.0.38

        <h3>Installation</h3>

        <p>1. Install Junte Encapsuler with
            <jnt-link source="https://gitlab.com/junte/junte-encapsuler" target="_blank">npm</jnt-link>
            :
        </p>

        <ngx-prism language="js">
            npm install junte-encapsuler --save
        </ngx-prism>

        <p>2. Once installed you need add some scripts to <span file>package.json</span> for encapsulate your components
        </p>

        <ngx-prism language="js"><pre>
"encapsulation": "gulp build --gulpfile node_modules/junte-encapsuler/encapsulation.js",
"encapsulation:watch": "gulp build --gulpfile node_modules/junte-encapsuler/encapsulation.js --watch"</pre>
        </ngx-prism>

        <p>3. Use npm run encapsulation (:watch) for encapsulate your components templates and styles.</p>

        <h3>Encapsulation</h3>

        <h4>[host] and [child-of] attributes:</h4>

        <p>In order for our encapsulation to work, you need to adds the host='selector' attribute using @HostBinding,
            this will provide an encapsulation of component styles.</p>
        <p>To encapsulate the styles of elements inside a
            component, our encapsulator automatically adds the child-of='selector' attribute to them.</p>

        <h3>Example</h3>

        <p>Bind host attribute to <span file>test.component.ts</span> file</p>
        <ngx-prism language="js">@HostBinding('attr.host') host = 'app-test-host';</ngx-prism>

        <p>Add <span file>build.json</span> to component folder:</p>

        <ngx-prism language="json">
<pre><![CDATA[
    {
    "encapsuler": [
    {
      "host": "app-test-host",
      "html": {
    "from": "test.component.html",
    "to": "test.encapsulated.html"
      },
      "scss": {
    "from": "test.component.scss",
    "to": "../../assets/styles/components/test/test.scss"
      }
    }
  ]
}
]]></pre>
        </ngx-prism>

        <p>Change templateUrl and remove styleUrls to test.encapsulated</p>

        <ngx-prism language="js">
<pre><![CDATA[
templateUrl: './test.encapsulated.html'
]]></pre>
        </ngx-prism>

        <p>Import encapsulated style from builder path to global loaded styles</p>

        <ngx-prism language="js">
<pre><![CDATA[
@import "assets/styles/components/test/test";
]]></pre>
        </ngx-prism>

        <h4>[host] and [child-of] example:</h4>

        <jnt-row>
            <jnt-col [mobile]="12" [desktop]="6">
                <p><span file>test.component.html</span> before:</p>

                <ngx-prism language="html">
<pre><![CDATA[
<h1>Test component</h1>
<form>
    <input type="text">
    <app-button>Test button</app-button>
</form>
]]></pre>
                </ngx-prism>
            </jnt-col>
            <jnt-col [mobile]="12" [desktop]="6">
                <p><span file>test.encapsulated.html</span> after:</p>

                <ngx-prism language="html">
<pre><![CDATA[
<h1 child-of="app-test-host">Test component</h1>
<form child-of="app-test-host">
    <input child-of="app-test-host" type="text"/>
    <app-button child-of="app-test-host">Test button</app-button>
</form>
]]></pre>
                </ngx-prism>
            </jnt-col>
        </jnt-row>

        <jnt-row>
            <jnt-col [mobile]="12" [desktop]="6">
                <p><span file>test.component.scss</span> before:</p>

                <ngx-prism language="css">
<pre><![CDATA[
@import "variables";
@import "../button/button";

:host {
    display: block;
    padding: 16px;
    border: 1px solid $jnt-primary-color;
}

h1 {
    color: $jnt-primary-color;
}

form {
    background-color: $jnt-secondary-background;
    padding: 8px;

    input {
    margin-right: 16px;
    border-radius: $jnt-corner-normal;
    padding: 8px 16px;
  }

  @include app-button((
    padding: $jnt-gutter-normal,
    color: $jnt-success-color
  ), '&', false, 'merge');
}
]]></pre>
                </ngx-prism>
            </jnt-col>
            <jnt-col [mobile]="12" [desktop]="6">
                <p><span file>test.scss</span> after:</p>

                <ngx-prism language="css">
<pre><![CDATA[
@import "variables";
@import "../button/button";

[host=app-test-host] {
    display: block;
    padding: 16px;
    border: 1px solid $jnt-primary-color;
}

h1[child-of=app-test-host] {
    color: $jnt-primary-color;
}

form[child-of=app-test-host] {
    background-color: $jnt-secondary-background;
    padding: 8px;

    input[child-of=app-test-host] {
    margin-right: 16px;
    border-radius: $jnt-corner-normal;
    padding: 8px 16px;
  }

  @include app-button((
    padding: $jnt-gutter-normal,
    color: $jnt-success-color
  ), '&', false, 'merge');
}
]]></pre>
                </ngx-prism>
            </jnt-col>
        </jnt-row>

        <app-test></app-test>
    </jnt-container>
</jnt-app-body>
